Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jgrapht.graph
Class AsUndirectedGraph<V,E>

    java.lang.Object
      org.jgrapht.graph.AbstractGraph<V,E>
          org.jgrapht.graph.GraphDelegator<V,E>
              org.jgrapht.graph.AsUndirectedGraph<V,E>

All Implemented Interfaces:
  java.io.Serializable, Graph<V,E>, UndirectedGraph<V,E>

    public class AsUndirectedGraph<V,E>

extends GraphDelegator<V,E>
implements java.io.Serializable, UndirectedGraph<V,E>

An undirected view of the backing directed graph specified in the constructor. This graph allows modules to apply algorithms designed for undirected graphs to a directed graph by simply ignoring edge direction. If the backing directed graph is an oriented graph, then the view will be a simple graph; otherwise, it will be a multigraph. Query operations on this graph "read through" to the backing graph. Attempts to add edges will result in an `UnsupportedOperationException`, but vertex addition/removal and edge removal are all supported (and immediately reflected in the backing graph).

Note that edges returned by this graph's accessors are really just the edges of the underlying directed graph. Since there is no interface distinction between directed and undirected edges, this detail should be irrelevant to algorithms.

This graph does not pass the hashCode and equals operations through to the backing graph, but relies on `Object`'s `equals` and `hashCode` methods. This graph will be serializable if the backing graph is serializable.

Since:
  Aug 14, 2003
Author:
  John V. Sichi
See Also:
  Serialized Form

Constructor Summary
`AsUndirectedGraph(DirectedGraph<V,E> g)` Constructor for AsUndirectedGraph.

Method Summary
`E` | `addEdge(V sourceVertex, V targetVertex)` Creates a new edge in this graph, going from the source vertex to the target vertex, and returns the created edge.
`boolean` | `addEdge(V sourceVertex, V targetVertex, E e)` Adds the specified edge to this graph, going from the source vertex to the target vertex.
`int` | `degreeOf(V vertex)` Returns the degree of the specified vertex.
`java.util.Set<E>` | `getAllEdges(V sourceVertex, V targetVertex)` Returns a set of all edges connecting source vertex to target vertex if such vertices exist in this graph.
`E` | `getEdge(V sourceVertex, V targetVertex)` Returns an edge connecting source vertex to target vertex if such vertices and such edge exist in this graph.
`java.util.Set<E>` | `incomingEdgesOf(V vertex)`
`int` | `inDegreeOf(V vertex)`
`int` | `outDegreeOf(V vertex)`
`java.util.Set<E>` | `outgoingEdgesOf(V vertex)`
`java.lang.String` | `toString()` Returns a string of the parenthesized pair (V, E) representing this G=(V,E) graph.

Methods inherited from class org.jgrapht.graph.GraphDelegator
`addVertex, containsEdge, containsVertex, edgeSet, edgesOf, getEdgeFactory, getEdgeSource, getEdgeTarget, getEdgeWeight, removeEdge, removeEdge, removeVertex, setEdgeWeight, vertexSet`

Methods inherited from class org.jgrapht.graph.AbstractGraph
`assertVertexExist, containsEdge, removeAllEdges, removeAllEdges, removeAllEdges, removeAllVertices, toStringFromSets`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.jgrapht.Graph
`addVertex, containsEdge, containsEdge, containsVertex, edgeSet, edgesOf, getEdgeFactory, getEdgeSource, getEdgeTarget, getEdgeWeight, removeAllEdges, removeAllEdges, removeAllVertices, removeEdge, removeEdge, removeVertex, vertexSet`

Constructor Detail

### AsUndirectedGraph

    public AsUndirectedGraph(DirectedGraph<V,E> g)

  Constructor for AsUndirectedGraph.

  Parameters:
    `g` - the backing directed graph over which an undirected view is to be created.

Method Detail

### getAllEdges

    public java.util.Set<E> getAllEdges(V sourceVertex,
                                        V targetVertex)

  Description copied from interface: `Graph`
  Returns a set of all edges connecting source vertex to target vertex if such vertices exist in this graph. If any of the vertices does not exist or is `null`, returns `null`. If both vertices exist but no edges found, returns an empty set.

  In undirected graphs, some of the returned edges may have their source and target vertices in the opposite order. In simple graphs the returned set is either singleton set or empty set.

  Specified by:
    `getAllEdges` in interface `Graph<V,E>`
  Overrides:
    `getAllEdges` in class `GraphDelegator<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
  Returns:
    a set of all edges connecting source vertex to target vertex.
  See Also:
    `Graph.getAllEdges(Object, Object)`

### getEdge

    public E getEdge(V sourceVertex,
                     V targetVertex)

  Description copied from interface: `Graph`
  Returns an edge connecting source vertex to target vertex if such vertices and such edge exist in this graph. Otherwise returns `null`. If any of the specified vertices is `null` returns `null`

  In undirected graphs, the returned edge may have its source and target vertices in the opposite order.

  Specified by:
    `getEdge` in interface `Graph<V,E>`
  Overrides:
    `getEdge` in class `GraphDelegator<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
  Returns:
    an edge connecting source vertex to target vertex.
  See Also:
    `Graph.getEdge(Object, Object)`

### addEdge

    public E addEdge(V sourceVertex,
                     V targetVertex)

  Description copied from interface: `Graph`
  Creates a new edge in this graph, going from the source vertex to the target vertex, and returns the created edge. Some graphs do not allow edge-multiplicity. In such cases, if the graph already contains an edge from the specified source to the specified target, than this method does not change the graph and returns `null`.

  The source and target vertices must already be contained in this graph. If they are not found in graph IllegalArgumentException is thrown.

  This method creates the new edge `e` using this graph's `EdgeFactory`. For the new edge to be added `e` must not be equal to any other edge the graph (even if the graph allows edge-multiplicity). More formally, the graph must not contain any edge `e2` such that `e2.equals(e)`. If such `e2` is found then the newly created edge `e` is abandoned, the method leaves this graph unchanged returns `null`.

  Specified by:
    `addEdge` in interface `Graph<V,E>`
  Overrides:
    `addEdge` in class `GraphDelegator<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
  Returns:
    The newly created edge if added to the graph, otherwise `null`.
  See Also:
    `Graph.addEdge(Object, Object)`

### addEdge

    public boolean addEdge(V sourceVertex,
                           V targetVertex,
                           E e)

  Description copied from interface: `Graph`
  Adds the specified edge to this graph, going from the source vertex to the target vertex. More formally, adds the specified edge, `e`, to this graph if this graph contains no edge `e2` such that `e2.equals(e)`. If this graph already contains such an edge, the call leaves this graph unchanged and returns `false`. Some graphs do not allow edge-multiplicity. In such cases, if the graph already contains an edge from the specified source to the specified target, than this method does not change the graph and returns `false`. If the edge was added to the graph, returns `true`.

  The source and target vertices must already be contained in this graph. If they are not found in graph IllegalArgumentException is thrown.

  Specified by:
    `addEdge` in interface `Graph<V,E>`
  Overrides:
    `addEdge` in class `GraphDelegator<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
    `e` - edge to be added to this graph.
  Returns:
    `true` if this graph did not already contain the specified edge.
  See Also:
    `Graph.addEdge(Object, Object, Object)`

### degreeOf

    public int degreeOf(V vertex)

  Description copied from interface: `UndirectedGraph`
  Returns the degree of the specified vertex. A degree of a vertex in an undirected graph is the number of edges touching that vertex.

  Specified by:
    `degreeOf` in interface `UndirectedGraph<V,E>`
  Overrides:
    `degreeOf` in class `GraphDelegator<V,E>`
  Parameters:
    `vertex` - vertex whose degree is to be calculated.
  Returns:
    the degree of the specified vertex.
  See Also:
    `UndirectedGraph.degreeOf(Object)`

### inDegreeOf

    public int inDegreeOf(V vertex)

  Overrides:
    `inDegreeOf` in class `GraphDelegator<V,E>`
  See Also:
    `DirectedGraph.inDegreeOf(Object)`

### incomingEdgesOf

    public java.util.Set<E> incomingEdgesOf(V vertex)

  Overrides:
    `incomingEdgesOf` in class `GraphDelegator<V,E>`
  See Also:
    `DirectedGraph.incomingEdgesOf(Object)`

### outDegreeOf

    public int outDegreeOf(V vertex)

  Overrides:
    `outDegreeOf` in class `GraphDelegator<V,E>`
  See Also:
    `DirectedGraph.outDegreeOf(Object)`

### outgoingEdgesOf

    public java.util.Set<E> outgoingEdgesOf(V vertex)

  Overrides:
    `outgoingEdgesOf` in class `GraphDelegator<V,E>`
  See Also:
    `DirectedGraph.outgoingEdgesOf(Object)`

### toString

    public java.lang.String toString()

  Description copied from class: `AbstractGraph`
  Returns a string of the parenthesized pair (V, E) representing this G=(V,E) graph. 'V' is the string representation of the vertex set, and 'E' is the string representation of the edge set.

  Overrides:
    `toString` in class `GraphDelegator<V,E>`
  Returns:
    a string representation of this graph.
  See Also:
    `AbstractGraph.toString()`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD